<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<title>DUNE Warm Interface Board: /home/dan/work/DUNE/dune-wib.firmware/trunk/cores/DCC_FEMB_PLL_sim/mentor/msim_setup.tcl Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">DUNE Warm Interface Board
   </div>
   <div id="projectbrief">Firmware for the DUNE Warm Interface Board (WIB)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="annotated.html"><span>Design&#160;Unit&#160;List</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Variables</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_51d9c9f08f6806a0f97badf342e5b4d7.html">cores</a></li><li class="navelem"><a class="el" href="dir_93e5537d3c7362da495e490c159bb7a5.html">DCC_FEMB_PLL_sim</a></li><li class="navelem"><a class="el" href="dir_f4cb264e7f6c52df0f25a55cf6bbaff9.html">mentor</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">msim_setup.tcl</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"># (C) 2001-2017 Altera Corporation. All rights reserved.</div>
</span><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"></span><span class="comment"># Your use of Altera Corporation&#39;s design tools, logic functions and </div>
</span><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"></span><span class="comment"># other software and tools, and its AMPP partner logic functions, and </div>
</span><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"></span><span class="comment"># any output files any of the foregoing (including device programming </div>
</span><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"></span><span class="comment"># or simulation files), and any associated documentation or information </div>
</span><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"></span><span class="comment"># are expressly subject to the terms and conditions of the Altera </div>
</span><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"></span><span class="comment"># Program License Subscription Agreement, Altera MegaCore Function </div>
</span><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"></span><span class="comment"># License Agreement, or other applicable license agreement, including, </div>
</span><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"></span><span class="comment"># without limitation, that your use is for the sole purpose of </div>
</span><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"></span><span class="comment"># programming logic devices manufactured by Altera and sold by Altera </div>
</span><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"></span><span class="comment"># or its authorized distributors. Please refer to the applicable </div>
</span><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"></span><span class="comment"># agreement for further details.</div>
</span><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"></span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"># ----------------------------------------</div>
</span><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"></span><span class="comment"># Auto-generated simulation script msim_setup.tcl</div>
</span><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"></span><span class="comment"># ----------------------------------------</div>
</span><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"></span><span class="comment"># This script provides commands to simulate the following IP detected in</div>
</span><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"></span><span class="comment"># your Quartus project:</div>
</span><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"></span><span class="comment">#     DCC_FEMB_PLL</div>
</span><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"></span><span class="comment"># </div>
</span><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"></span><span class="comment"># Altera recommends that you source this Quartus-generated IP simulation</div>
</span><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"></span><span class="comment"># script from your own customized top-level script, and avoid editing this</div>
</span><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"></span><span class="comment"># generated script.</div>
</span><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"></span><span class="comment"># </div>
</span><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"></span><span class="comment"># To write a top-level script that compiles Altera simulation libraries and</div>
</span><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment"></span><span class="comment"># the Quartus-generated IP in your project, along with your design and</div>
</span><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="comment"></span><span class="comment"># testbench files, copy the text from the TOP-LEVEL TEMPLATE section below</div>
</span><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="comment"></span><span class="comment"># into a new file, e.g. named &quot;mentor.do&quot;, and modify the text as directed.</div>
</span><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="comment"></span><span class="comment"># </div>
</span><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="comment"></span><span class="comment"># ----------------------------------------</div>
</span><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="comment"></span><span class="comment"># # TOP-LEVEL TEMPLATE - BEGIN</div>
</span><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="comment"></span><span class="comment"># #</div>
</span><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="comment"></span><span class="comment"># # QSYS_SIMDIR is used in the Quartus-generated IP simulation script to</div>
</span><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="comment"></span><span class="comment"># # construct paths to the files required to simulate the IP in your Quartus</div>
</span><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="comment"></span><span class="comment"># # project. By default, the IP script assumes that you are launching the</div>
</span><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="comment"></span><span class="comment"># # simulator from the IP script location. If launching from another</div>
</span><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="comment"></span><span class="comment"># # location, set QSYS_SIMDIR to the output directory you specified when you</div>
</span><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="comment"></span><span class="comment"># # generated the IP script, relative to the directory from which you launch</div>
</span><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="comment"></span><span class="comment"># # the simulator.</div>
</span><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="comment"></span><span class="comment"># #</div>
</span><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="comment"></span><span class="comment"># set QSYS_SIMDIR &lt;script generation output directory&gt;</div>
</span><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="comment"></span><span class="comment"># #</div>
</span><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="comment"></span><span class="comment"># # Source the generated IP simulation script.</div>
</span><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="comment"></span><span class="comment"># source $QSYS_SIMDIR/mentor/msim_setup.tcl</div>
</span><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="comment"></span><span class="comment"># #</div>
</span><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="comment"></span><span class="comment"># # Set any compilation options you require (this is unusual).</div>
</span><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="comment"></span><span class="comment"># set USER_DEFINED_COMPILE_OPTIONS &lt;compilation options&gt;</div>
</span><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;<span class="comment"></span><span class="comment"># #</div>
</span><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;<span class="comment"></span><span class="comment"># # Call command to compile the Quartus EDA simulation library.</div>
</span><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="comment"></span><span class="comment"># dev_com</div>
</span><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="comment"></span><span class="comment"># #</div>
</span><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="comment"></span><span class="comment"># # Call command to compile the Quartus-generated IP simulation files.</div>
</span><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="comment"></span><span class="comment"># com</div>
</span><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="comment"></span><span class="comment"># #</div>
</span><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="comment"></span><span class="comment"># # Add commands to compile all design files and testbench files, including</div>
</span><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="comment"></span><span class="comment"># # the top level. (These are all the files required for simulation other</div>
</span><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="comment"></span><span class="comment"># # than the files compiled by the Quartus-generated IP simulation script)</div>
</span><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="comment"></span><span class="comment"># #</div>
</span><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="comment"></span><span class="comment"># vlog &lt;compilation options&gt; &lt;design and testbench files&gt;</div>
</span><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="comment"></span><span class="comment"># #</div>
</span><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="comment"></span><span class="comment"># # Set the top-level simulation or testbench module/entity name, which is</div>
</span><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;<span class="comment"></span><span class="comment"># # used by the elab command to elaborate the top level.</div>
</span><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;<span class="comment"></span><span class="comment"># #</div>
</span><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;<span class="comment"></span><span class="comment"># set TOP_LEVEL_NAME &lt;simulation top&gt;</div>
</span><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;<span class="comment"></span><span class="comment"># #</div>
</span><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;<span class="comment"></span><span class="comment"># # Set any elaboration options you require.</div>
</span><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;<span class="comment"></span><span class="comment"># set USER_DEFINED_ELAB_OPTIONS &lt;elaboration options&gt;</div>
</span><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;<span class="comment"></span><span class="comment"># #</div>
</span><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;<span class="comment"></span><span class="comment"># # Call command to elaborate your design and testbench.</div>
</span><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;<span class="comment"></span><span class="comment"># elab</div>
</span><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;<span class="comment"></span><span class="comment"># #</div>
</span><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;<span class="comment"></span><span class="comment"># # Run the simulation.</div>
</span><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;<span class="comment"></span><span class="comment"># run -a</div>
</span><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;<span class="comment"></span><span class="comment"># #</div>
</span><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;<span class="comment"></span><span class="comment"># # Report success to the shell.</div>
</span><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;<span class="comment"></span><span class="comment"># exit -code 0</div>
</span><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;<span class="comment"></span><span class="comment"># #</div>
</span><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;<span class="comment"></span><span class="comment"># # TOP-LEVEL TEMPLATE - END</div>
</span><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;<span class="comment"></span><span class="comment"># ----------------------------------------</div>
</span><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;<span class="comment"></span><span class="comment"># </div>
</span><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;<span class="comment"></span><span class="comment"># IP SIMULATION SCRIPT</div>
</span><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;<span class="comment"></span><span class="comment"># ----------------------------------------</div>
</span><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;<span class="comment"></span><span class="comment"># If DCC_FEMB_PLL is one of several IP cores in your</div>
</span><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;<span class="comment"></span><span class="comment"># Quartus project, you can generate a simulation script</div>
</span><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;<span class="comment"></span><span class="comment"># suitable for inclusion in your top-level simulation</div>
</span><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;<span class="comment"></span><span class="comment"># script by running the following command line:</div>
</span><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;<span class="comment"></span><span class="comment"># </div>
</span><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;<span class="comment"></span><span class="comment"># ip-setup-simulation --quartus-project=&lt;quartus project&gt;</div>
</span><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;<span class="comment"></span><span class="comment"># </div>
</span><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;<span class="comment"></span><span class="comment"># ip-setup-simulation will discover the Altera IP</div>
</span><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;<span class="comment"></span><span class="comment"># within the Quartus project, and generate a unified</div>
</span><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;<span class="comment"></span><span class="comment"># script which supports all the Altera IP within the design.</div>
</span><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;<span class="comment"></span><span class="comment"># ----------------------------------------</div>
</span><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;<span class="comment"></span><span class="comment"># ACDS 16.0 211 linux 2017.03.08.13:27:32</div>
</span><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;<span class="comment"></span></div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;<span class="comment"># ----------------------------------------</div>
</span><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;<span class="comment"></span><span class="comment"># Initialize variables</div>
</span><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;<span class="comment"></span><span class="keyword">if</span> ![info exists SYSTEM_INSTANCE_NAME] { </div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;  <span class="keyword">set</span> SYSTEM_INSTANCE_NAME &quot;&quot;<span class="comment"></div>
</span><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;<span class="comment"></span>} <span class="keyword">elseif</span> { ![ string match &quot;&quot; $SYSTEM_INSTANCE_NAME ]} { </div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;  <span class="keyword">set</span> SYSTEM_INSTANCE_NAME &quot;/$SYSTEM_INSTANCE_NAME&quot;<span class="comment"></div>
</span><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;<span class="comment"></span>}<span class="comment"></div>
</span><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;<span class="comment"></span></div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;<span class="keyword">if</span> ![info exists TOP_LEVEL_NAME] { </div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;  <span class="keyword">set</span> TOP_LEVEL_NAME &quot;DCC_FEMB_PLL&quot;<span class="comment"></div>
</span><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;<span class="comment"></span>}<span class="comment"></div>
</span><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;<span class="comment"></span></div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;<span class="keyword">if</span> ![info exists QSYS_SIMDIR] { </div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;  <span class="keyword">set</span> QSYS_SIMDIR &quot;./../&quot;<span class="comment"></div>
</span><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;<span class="comment"></span>}<span class="comment"></div>
</span><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;<span class="comment"></span></div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;<span class="keyword">if</span> ![info exists QUARTUS_INSTALL_DIR] { </div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;  <span class="keyword">set</span> QUARTUS_INSTALL_DIR &quot;/opt/altera/16.0/quartus/&quot;<span class="comment"></div>
</span><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;<span class="comment"></span>}<span class="comment"></div>
</span><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;<span class="comment"></span></div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;<span class="keyword">if</span> ![info exists USER_DEFINED_COMPILE_OPTIONS] { </div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;  <span class="keyword">set</span> USER_DEFINED_COMPILE_OPTIONS &quot;&quot;<span class="comment"></div>
</span><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;<span class="comment"></span>}<span class="comment"></div>
</span><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;<span class="comment"></span><span class="keyword">if</span> ![info exists USER_DEFINED_ELAB_OPTIONS] { </div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;  <span class="keyword">set</span> USER_DEFINED_ELAB_OPTIONS &quot;&quot;<span class="comment"></div>
</span><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;<span class="comment"></span>}<span class="comment"></div>
</span><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;<span class="comment"></span></div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;<span class="comment"># ----------------------------------------</div>
</span><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;<span class="comment"></span><span class="comment"># Initialize simulation properties - DO NOT MODIFY!</div>
</span><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;<span class="comment"></span><span class="keyword">set</span> ELAB_OPTIONS &quot;&quot;<span class="comment"></div>
</span><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;<span class="comment"></span><span class="keyword">set</span> SIM_OPTIONS &quot;&quot;<span class="comment"></div>
</span><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;<span class="comment"></span><span class="keyword">if</span> ![ string match &quot;*-64 vsim*&quot; [ vsim -version ] ] {</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;} <span class="keyword">else</span> {</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;}<span class="comment"></div>
</span><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;<span class="comment"></span></div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;<span class="comment"># ----------------------------------------</div>
</span><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;<span class="comment"></span><span class="comment"># Copy ROM/RAM files to simulation directory</div>
</span><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;<span class="comment"></span>alias file_copy {</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;  echo &quot;\[exec\] file_copy&quot;</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;}<span class="comment"></div>
</span><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;<span class="comment"></span></div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;<span class="comment"># ----------------------------------------</div>
</span><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;<span class="comment"></span><span class="comment"># Create compilation libraries</div>
</span><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;<span class="comment"></span><span class="keyword">proc</span> ensure_lib { lib } { <span class="keyword">if</span> ![file isdirectory $lib] { vlib $lib}}<span class="comment"></div>
</span><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;<span class="comment"></span><a class="code" href="WIB__TSE__sim_2mentor_2msim__setup_8tcl.html#ac64a75de610edc7614fd48530ff2ba1f" title="ensure_lib">ensure_lib</a>          ./libraries/<span class="comment">     </div>
</span><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;<span class="comment"></span><a class="code" href="WIB__TSE__sim_2mentor_2msim__setup_8tcl.html#ac64a75de610edc7614fd48530ff2ba1f" title="ensure_lib">ensure_lib</a>          ./libraries/work/<span class="comment"></div>
</span><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;<span class="comment"></span>vmap       work     ./libraries/work/<span class="comment"></div>
</span><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;<span class="comment"></span>vmap       work_lib ./libraries/work/<span class="comment"></div>
</span><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;<span class="comment"></span><span class="keyword">if</span> ![ string match &quot;*ModelSim ALTERA*&quot; [ vsim -version ] ] {</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;  <a class="code" href="WIB__TSE__sim_2mentor_2msim__setup_8tcl.html#ac64a75de610edc7614fd48530ff2ba1f" title="ensure_lib">ensure_lib</a>              ./libraries/altera/<span class="comment">      </div>
</span><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;<span class="comment"></span>  vmap       altera       ./libraries/altera/<span class="comment">      </div>
</span><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;<span class="comment"></span>  <a class="code" href="WIB__TSE__sim_2mentor_2msim__setup_8tcl.html#ac64a75de610edc7614fd48530ff2ba1f" title="ensure_lib">ensure_lib</a>              ./libraries/lpm/<span class="comment">         </div>
</span><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;<span class="comment"></span>  vmap       lpm          ./libraries/lpm/<span class="comment">         </div>
</span><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;<span class="comment"></span>  <a class="code" href="WIB__TSE__sim_2mentor_2msim__setup_8tcl.html#ac64a75de610edc7614fd48530ff2ba1f" title="ensure_lib">ensure_lib</a>              ./libraries/sgate/<span class="comment">       </div>
</span><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;<span class="comment"></span>  vmap       sgate        ./libraries/sgate/<span class="comment">       </div>
</span><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;<span class="comment"></span>  <a class="code" href="WIB__TSE__sim_2mentor_2msim__setup_8tcl.html#ac64a75de610edc7614fd48530ff2ba1f" title="ensure_lib">ensure_lib</a>              ./libraries/altera_mf/<span class="comment">   </div>
</span><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;<span class="comment"></span>  vmap       altera_mf    ./libraries/altera_mf/<span class="comment">   </div>
</span><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;<span class="comment"></span>  <a class="code" href="WIB__TSE__sim_2mentor_2msim__setup_8tcl.html#ac64a75de610edc7614fd48530ff2ba1f" title="ensure_lib">ensure_lib</a>              ./libraries/altera_lnsim/<span class="comment"></div>
</span><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;<span class="comment"></span>  vmap       altera_lnsim ./libraries/altera_lnsim/<span class="comment"></div>
</span><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;<span class="comment"></span>  <a class="code" href="WIB__TSE__sim_2mentor_2msim__setup_8tcl.html#ac64a75de610edc7614fd48530ff2ba1f" title="ensure_lib">ensure_lib</a>              ./libraries/arriav/<span class="comment">      </div>
</span><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;<span class="comment"></span>  vmap       arriav       ./libraries/arriav/<span class="comment">      </div>
</span><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;<span class="comment"></span>}<span class="comment"></div>
</span><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;<span class="comment"></span></div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;<span class="comment"># ----------------------------------------</div>
</span><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;<span class="comment"></span><span class="comment"># Compile device library files</div>
</span><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;<span class="comment"></span>alias dev_com {</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;  echo &quot;\[exec\] dev_com&quot;</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;  if ![ <span class="keyword">string</span> match &quot;*ModelSim ALTERA*&quot; [ vsim -version ] ] {</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;    eval  vcom $USER_DEFINED_COMPILE_OPTIONS     &quot;$QUARTUS_INSTALL_DIR/eda/sim_lib/altera_syn_attributes.vhd&quot;        -work altera      </div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;    eval  vcom $USER_DEFINED_COMPILE_OPTIONS     &quot;$QUARTUS_INSTALL_DIR/eda/sim_lib/altera_standard_functions.vhd&quot;    -work altera      </div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;    eval  vcom $USER_DEFINED_COMPILE_OPTIONS     &quot;$QUARTUS_INSTALL_DIR/eda/sim_lib/alt_dspbuilder_package.vhd&quot;       -work altera      </div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;    eval  vcom $USER_DEFINED_COMPILE_OPTIONS     &quot;$QUARTUS_INSTALL_DIR/eda/sim_lib/altera_europa_support_lib.vhd&quot;    -work altera      </div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;    eval  vcom $USER_DEFINED_COMPILE_OPTIONS     &quot;$QUARTUS_INSTALL_DIR/eda/sim_lib/altera_primitives_components.vhd&quot; -work altera      </div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;    eval  vcom $USER_DEFINED_COMPILE_OPTIONS     &quot;$QUARTUS_INSTALL_DIR/eda/sim_lib/altera_primitives.vhd&quot;            -work altera      </div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;    eval  vcom $USER_DEFINED_COMPILE_OPTIONS     &quot;$QUARTUS_INSTALL_DIR/eda/sim_lib/220pack.vhd&quot;                      -work lpm         </div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;    eval  vcom $USER_DEFINED_COMPILE_OPTIONS     &quot;$QUARTUS_INSTALL_DIR/eda/sim_lib/220model.vhd&quot;                     -work lpm         </div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;    eval  vcom $USER_DEFINED_COMPILE_OPTIONS     &quot;$QUARTUS_INSTALL_DIR/eda/sim_lib/sgate_pack.vhd&quot;                   -work sgate       </div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;    eval  vcom $USER_DEFINED_COMPILE_OPTIONS     &quot;$QUARTUS_INSTALL_DIR/eda/sim_lib/sgate.vhd&quot;                        -work sgate       </div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;    eval  vcom $USER_DEFINED_COMPILE_OPTIONS     &quot;$QUARTUS_INSTALL_DIR/eda/sim_lib/altera_mf_components.vhd&quot;         -work altera_mf   </div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;    eval  vcom $USER_DEFINED_COMPILE_OPTIONS     &quot;$QUARTUS_INSTALL_DIR/eda/sim_lib/altera_mf.vhd&quot;                    -work altera_mf   </div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;    eval  vlog -sv $USER_DEFINED_COMPILE_OPTIONS &quot;$QUARTUS_INSTALL_DIR/eda/sim_lib/mentor/altera_lnsim_for_vhdl.sv&quot;  -work altera_lnsim</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;    eval  vcom $USER_DEFINED_COMPILE_OPTIONS     &quot;$QUARTUS_INSTALL_DIR/eda/sim_lib/altera_lnsim_components.vhd&quot;      -work altera_lnsim</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;    eval  vlog $USER_DEFINED_COMPILE_OPTIONS     &quot;$QUARTUS_INSTALL_DIR/eda/sim_lib/mentor/arriav_atoms_ncrypt.v&quot;     -work arriav      </div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;    eval  vcom $USER_DEFINED_COMPILE_OPTIONS     &quot;$QUARTUS_INSTALL_DIR/eda/sim_lib/arriav_atoms.vhd&quot;                 -work arriav      </div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;    eval  vcom $USER_DEFINED_COMPILE_OPTIONS     &quot;$QUARTUS_INSTALL_DIR/eda/sim_lib/arriav_components.vhd&quot;            -work arriav      </div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;  }</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;}<span class="comment"></div>
</span><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;<span class="comment"></span></div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;<span class="comment"># ----------------------------------------</div>
</span><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;<span class="comment"></span><span class="comment"># Compile the design files in correct order</div>
</span><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;<span class="comment"></span>alias com {</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;  echo &quot;\[exec\] com&quot;</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;  eval  vcom $USER_DEFINED_COMPILE_OPTIONS &quot;$QSYS_SIMDIR/DCC_FEMB_PLL.vho&quot;</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;}<span class="comment"></div>
</span><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;<span class="comment"></span></div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;<span class="comment"># ----------------------------------------</div>
</span><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;<span class="comment"></span><span class="comment"># Elaborate top level design</div>
</span><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;<span class="comment"></span>alias elab {</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;  echo &quot;\[exec\] elab&quot;</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;  eval vsim -t ps $ELAB_OPTIONS $USER_DEFINED_ELAB_OPTIONS -L work -L work_lib -L altera -L lpm -L sgate -L altera_mf -L altera_lnsim -L arriav $TOP_LEVEL_NAME</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;}<span class="comment"></div>
</span><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;<span class="comment"></span></div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;<span class="comment"># ----------------------------------------</div>
</span><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;<span class="comment"></span><span class="comment"># Elaborate the top level design with novopt option</div>
</span><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;<span class="comment"></span>alias elab_debug {</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;  echo &quot;\[exec\] elab_debug&quot;</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;  eval vsim -novopt -t ps $ELAB_OPTIONS $USER_DEFINED_ELAB_OPTIONS -L work -L work_lib -L altera -L lpm -L sgate -L altera_mf -L altera_lnsim -L arriav $TOP_LEVEL_NAME</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;}<span class="comment"></div>
</span><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;<span class="comment"></span></div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;<span class="comment"># ----------------------------------------</div>
</span><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;<span class="comment"></span><span class="comment"># Compile all the design files and elaborate the top level design</div>
</span><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;<span class="comment"></span>alias ld &quot;</div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;  dev_com</div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;  com</div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;  elab</div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;&quot;<span class="comment"></div>
</span><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;<span class="comment"></span></div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;<span class="comment"># ----------------------------------------</div>
</span><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;<span class="comment"></span><span class="comment"># Compile all the design files and elaborate the top level design with -novopt</div>
</span><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;<span class="comment"></span>alias ld_debug &quot;</div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;  dev_com</div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;  com</div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;  elab_debug</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;&quot;<span class="comment"></div>
</span><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;<span class="comment"></span></div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;<span class="comment"># ----------------------------------------</div>
</span><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;<span class="comment"></span><span class="comment"># Print out user commmand line aliases</div>
</span><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;<span class="comment"></span>alias h {</div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;  echo &quot;List Of Command Line Aliases&quot;</div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;  echo</div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;  echo &quot;file_copy                     -- Copy ROM/RAM files to simulation directory&quot;</div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;  echo</div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;  echo &quot;dev_com                       -- Compile device library files&quot;</div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;  echo</div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;  echo &quot;com                           -- Compile the design files in correct order&quot;</div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;  echo</div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;  echo &quot;elab                          -- Elaborate top level design&quot;</div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;  echo</div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;  echo &quot;elab_debug                    -- Elaborate the top level design with novopt option&quot;</div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;  echo</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;  echo &quot;ld                            -- Compile all the design files and elaborate the top level design&quot;</div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;  echo</div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;  echo &quot;ld_debug                      -- Compile all the design files and elaborate the top level design with -novopt&quot;</div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;  echo</div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;  echo </div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;  echo</div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;  echo &quot;List Of Variables&quot;</div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;  echo</div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;  echo &quot;TOP_LEVEL_NAME                -- Top level module name.&quot;</div>
<div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;  echo &quot;                                 For most designs, this should be overridden&quot;</div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;  echo &quot;                                 to enable the elab/elab_debug aliases.&quot;</div>
<div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;  echo</div>
<div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;  echo &quot;SYSTEM_INSTANCE_NAME          -- Instantiated system module name inside top level module.&quot;</div>
<div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;  echo</div>
<div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;  echo &quot;QSYS_SIMDIR                   -- Qsys base simulation directory.&quot;</div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;  echo</div>
<div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;  echo &quot;QUARTUS_INSTALL_DIR           -- Quartus installation directory.&quot;</div>
<div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;  echo</div>
<div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;  echo &quot;USER_DEFINED_COMPILE_OPTIONS  -- User-defined compile options, added to com/dev_com aliases.&quot;</div>
<div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;  echo</div>
<div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;  echo &quot;USER_DEFINED_ELAB_OPTIONS     -- User-defined elaboration options, added to elab/elab_debug aliases.&quot;</div>
<div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;}<span class="comment"></div>
</span><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;<span class="comment"></span>file_copy<span class="comment"></div>
</span><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;<span class="comment"></span>h</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Wed Nov 1 2017 10:40:16 for DUNE Warm Interface Board by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.1
</small></address>
</body>
</html>
